/*
 * ===========================
 * VDK Builder
 * Version 2.0.1
 * March 2002
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
//
#ifndef _vdkb_nicebutton_h
// put your code below here
#define _vdkb_nicebutton_h
#include <vdk/evlisthandle.h>
#include <vdk/vdkcustombutton.h>

class VDKNiceButton: public VDKCustomButton
{
  protected:
  VDKPixbuf* normal_pix, *pixellated_pix,  *darkened_pix;
  bool OnEnter (VDKObject*,  GdkEvent*);
  bool OnLeave (VDKObject*,  GdkEvent*);
  bool OnClickRelease (VDKObject*,  GdkEvent*);
  bool OnClickPress (VDKObject*,  GdkEvent*);
  public:
  VDKNiceButton (VDKForm  *owner, 
                  const char *pixfile, 
                  const char *label = NULL, 
                  unsigned int type=VDK_CBUTTON_UNTOGGLED|VDK_CBUTTON_NORMAL,
                  GtkPositionType position=GTK_POS_RIGHT);
  
  VDKNiceButton (VDKForm *owner,
                   const char **pixdata,
                   const char *label = NULL,
                   unsigned int type=VDK_CBUTTON_UNTOGGLED|VDK_CBUTTON_NORMAL,
                   GtkPositionType position=GTK_POS_RIGHT);
  virtual ~VDKNiceButton () {}
  void Setup (void);
  DECLARE_EVENT_LIST (VDKNiceButton);
};
#endif 

