/*
 * ===========================
 * VDK Builder
 * Version 2.0.1
 * March 2002
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#ifndef _vdknicebuttonbar_h
// put your code below here
#define _vdknicebuttonbar_h
// #include <vdk/evlisthandle.h>
#include <vdk/siglisthandle.h>
#include <vdkb2/vdkb_nicebutton.h>
#include <vdk/frame.h>
#include <vdk/vdkprops.h>
typedef VDKList <VDKNiceButton> BList;
typedef VDKListIterator <VDKNiceButton> ButtonListIterator;
class VDKNiceButtonBar: public VDKFrame
{
  protected:
  BList blist;
  bool OnClick (VDKObject* sender);
  public:
    VDKNiceButtonBar (VDKForm* owner, 
      int mode = h_box, 
      int shadow = shadow_none);
    virtual ~ VDKNiceButtonBar ();
  void AddButton (const char** pixdata, 
                  const char* tip = NULL,
                  const char* text = NULL);
  void AddButton (const char* pixfile, 
                  const char* tip = NULL,
                  const char* text = NULL);
  VDKNiceButton* operator[](int n);
  VDKReadWriteValueProp <VDKNiceButtonBar, int> ButtonPressed;
  DECLARE_SIGNAL_LIST (VDKNiceButtonBar);
};

//
#endif

