/*
 * ===========================
 * VDK Builder
 * Version 0.1
 * Revision 0.0
 * November 1998
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#if USE_XDB
#include <vdkxdb2/vdkxdb.h>
#include <vdkxdb2/vdkxtable.h>
#endif
#if !HAVE_GNOME
#if ENABLE_NLS
#include <libintl.h>
//#define _(str) gettext(str)
#define _(str) \
    ( g_utf8_validate(gettext(str),-1,NULL) ? \
    gettext(str) : \
    g_locale_to_utf8(gettext(str),-1,NULL,NULL,NULL) )
#define N_(str) str
#else
#define _(str) str
#define N_(str) str 
#endif
#endif
#undef __REGEXP_LIBRARY_H__    // do not include builtin regex.h
#define __REGEXP_LIBRARY_H__ 1 // use it from libc6-dev package
#include <vdkb2/vdkb_ccpane.h> // order of #include directives is important!!!
#include <vdkb2/vdkb_prjman.h>
#include <vdkb2/vdkb.h>
#include <vdkb2/vdkb_FWizard.h>
#include <set>
#include "pixmaps/public.xpm"
#include "pixmaps/private.xpm"
#include "pixmaps/protected.xpm"
#include "pixmaps/refresh.xpm"
#include "pixmaps/add.xpm"
#include "pixmaps/classdecl.xpm"
#include "pixmaps/classdef.xpm"
static char buff[512];
extern VDKBuilder* TheApp;
////////////////////////////////////////////////////////////
DEFINE_SIGNAL_MAP(VDKBCCPane,VDKBox)
  ON_SIGNAL(class_tree,select_node_signal,OnSelectRow)//,
  //  ON_SIGNAL(toolbar,clicked_signal,HandleToolbar)
END_SIGNAL_MAP

DEFINE_EVENT_LIST(VDKBCCPane,VDKBox);
DEFINE_SIGNAL_LIST(VDKBCCPane,VDKBox);
////////////////////////////////////////////////////////////

VDKBCCPane::VDKBCCPane( VDKBProjectManager *own) : VDKBox(own), owner(own),proj(own)
{
//  proj = VDKBCCProject(own);
}

void
VDKBCCPane::Setup()
{
  VDKBox *box = new VDKBox( Owner(), v_box);
  // a separator
  VDKSeparator *sep = new VDKSeparator( Owner(),h_separator);
  box->Add(sep,l_justify,false,false,false);
  // the toolbar
  //toolbar = new VDKToolbar( Owner());
  toolbar =new VDKNiceButtonBar(Owner(),h_box,shadow_etched_in);
  //  toolbar->Style = GTK_TOOLBAR_BOTH; 

/*  toolbar->AddButton(add_xpm,NULL,
		     _(prjman_prompts[6])
		     );
*/
  /* 
  toolbar->AddButton(classdecl_xpm,NULL,
		     _(prjman_prompts[7]) 
		     );
  toolbar->AddButton(classdef_xpm,NULL,
		     _(prjman_prompts[8])
		     );
  toolbar->AddButton(refresh_xpm,NULL,
		     _(prjman_prompts[9])
		     );
  */ 
  toolbar->AddButton((const char**)classdecl_xpm,_(prjman_prompts[7]));
  toolbar->AddButton((const char**)classdef_xpm,_(prjman_prompts[8]));
  toolbar->AddButton((const char**)refresh_xpm,_(prjman_prompts[9]));
//  (*toolbar)[ADD_FUNCTION_BUTTON]->Enabled = false;
  (*toolbar)[DECLARATION_BUTTON]->Enabled = false;
  (*toolbar)[DEFINITION_BUTTON]->Enabled = false;
  (*toolbar)[UPDATE_CLASS_BUTTON]->Enabled = false;

  // toolbar->Borderless = true;
  box->Add(toolbar,l_justify,false,false,false);
  SignalConnect(toolbar,"clicked",&VDKBCCPane::HandleToolbar);

  // another sep
  sep = new VDKSeparator( Owner(),h_separator);
  box->Add(sep,l_justify,false,false,false);
  // the classes tree
  box->Add(class_tree = new VDKCustomTree( Owner(),1,NULL,GTK_SELECTION_SINGLE));
  class_tree->LineStyle = GTK_CTREE_LINES_DOTTED;
  // class_tree->Font = new VDKFont( Owner(), "helvetica 12");
  // cast white background to override some gtk-themes defaults
  class_tree->NormalBackground = clWhite;
  bar = new VDKPanelbar( Owner());
  box->Add(bar,l_justify,false,false,false);
  EventConnect(class_tree,"button_press_event", &VDKBCCPane::ClassBrowserButtonPress);
  Add(box);
  // makes a pop menu
  popmenu = new VDKMenu(owner);
  VDKMenuItem *nop = new VDKMenuItem(popmenu,_("Jump to sources"));
  nop->Enabled = false;
  popmenu->Separator();
  declared_item = new VDKMenuItem(popmenu,_("Where declared"),classdecl_xpm);
  defined_item = new VDKMenuItem(popmenu,_("Where defined"), classdef_xpm);
   /*
      better add it to owner, so will be surely
      destroyed even if never popped
  */
  owner->AddItem(popmenu);
  popmenu->Parent(this);
  SignalConnect(declared_item,"activate",&VDKBCCPane::JumpToSources);
  SignalConnect(defined_item,"activate",&VDKBCCPane::JumpToSources);
}

bool
VDKBCCPane::JumpToSources(VDKObject* sender)
{
  char *fname = NULL;
  char *cname = (char*) NULL;
  int lnum;
  VDKTreeNode cnode = NULL;
  VDKTreeNode node = class_tree->SelectedNode;
  if(! node)
    return true;
  char* sname = new char[strlen(class_tree->Key(node))+1];
  strcpy(sname, class_tree->Key(node));

  if( class_tree->IsLeaf(node)) // it is a function
    {
      cnode = GTK_CTREE_ROW(node)->parent; //get class node
      cname = class_tree->Key(cnode);
    }

  if(sender == declared_item)
    {
      fname = proj.get_decl_file_from_function(cname,sname);
      lnum = proj.get_decl_line_from_function(cname,sname);
      if(fname) EditFile( fname, lnum);
    }
  else if (sender == defined_item)
    {
      if( class_tree->IsLeaf(node)) // it is a function
	{
	  fname = proj.get_file_from_function(cname,sname);
	  lnum = proj.get_line_from_function(cname,sname);
	}
      else
	{
	  fname = proj.get_file_from_class(sname);
	  lnum = proj.get_line_from_class(sname);
	}
      if(fname)
	  EditFile( fname, lnum);
    }
  if(fname)
    delete[] fname;
  return true;
}


bool
VDKBCCPane::ClassBrowserButtonPress(VDKObject* sender, GdkEvent* event)
{
  GdkEventButton* e = (GdkEventButton*) event;
  VDKTreeNode node = class_tree->SelectedNode;
  if(! node)
    return false;
  else if(e->button == 3)
      popmenu->Popup();
  return false;
}

void
VDKBCCPane::on_update()
{
  reset_pane();
  reload_tree();
}

void
VDKBCCPane::reload_tree()
{
  char* text;
  set<string> classes; //sets are sorted...
  set<string> functions;
  class_pos cptr;
  set<string>::const_iterator class_it;
  set<string>::const_iterator func_it;
  cptr=proj.get_first_class();
  VDKTreeNode item, subitem;
  funct_pos fptr;
  while(cptr != proj.get_end_class())
    {
      classes.insert(proj.get_class(cptr).getname());
      cptr++;
    }   
  //
  class_it=classes.begin();
  class_tree->Freeze();

  while(class_it != classes.end())
    {
      text = (char*)(*class_it).c_str();
      item = class_tree->AddNode(&text,NULL,
				 false,false,class_xpm,class_xpm);

#	ifdef HAVE_VDKDEVEL
      if(!proj.get_class_from_name((*class_it).c_str()).get_parents().empty())
	{
	  vector<string> par =
	    proj.get_class_from_name((*class_it).c_str()).get_parents();
	  vector<string>::const_iterator pptr;
	  for(pptr=par.begin();pptr != par.end();pptr++)
	    {
	      text = (char*)(*pptr).c_str();
	      subitem = class_tree->AddNode(&text,item,
					    false,true,
					    class_xpm,class_xpm);
	    }
	}
#	endif

      fptr=proj.get_class_from_name
	((*class_it).c_str()).get_first_function();
      functions.erase(functions.begin(),functions.end());
      while(fptr != proj.get_class_from_name
	    ((*class_it).c_str()).get_last_function())
        {
	  functions.insert
	    (proj.get_class_from_name
	     ((*class_it).c_str()).get_function(fptr).getname()); //ugly
	  fptr++;
        }
      func_it=functions.begin();

      while(func_it != functions.end())
        {
	  text = (char*)(*func_it).c_str();
	  subitem = class_tree->AddNode(&text,item,
					false,true,
					get_func_image
					((*func_it).c_str(),
					(*class_it).c_str()));

	  func_it++;
        }
      class_it++;

      class_tree->Thaw();
      class_tree->SelectedNode = NULL;
    }
}

void
VDKBCCPane::reset_pane()
{
  class_tree->Clear();
}

void
VDKBCCPane::LoadClassTree(const char* dir)
{
  proj.setdirectory(dir);

  if(proj.update())
    {
      reload_tree();
      (*toolbar)[UPDATE_CLASS_BUTTON]->Enabled = true;
    }
}

char**
VDKBCCPane::get_func_image( const char* fname, const char* cname)
{
  unsigned int flag;
  char** res;
  flag = proj.get_class_from_name(cname).
    get_function_from_name(fname).get_flags();

  if ( flag & fprivate )
    res = private_xpm;
  else if ( flag & fprotected )
    res = protected_xpm;
  else
    res = public_xpm;

  return res;
}

bool
VDKBCCPane::HandleToolbar(VDKObject* )
{
  char *fname = NULL;
  char *cname = (char*) NULL;
  int lnum;
  VDKTreeNode cnode;
  int button = toolbar->ButtonPressed;
  VDKTreeNode node = class_tree->SelectedNode;
  char* sname = new char[strlen(class_tree->Key(node))+1];
  strcpy(sname, class_tree->Key(node));

  if( class_tree->IsLeaf(node)) // it is a function
    {
      cnode = GTK_CTREE_ROW(node)->parent;//get class node
      cname = class_tree->Key(cnode);
    }

  switch(button)
    {
/*    case ADD_FUNCTION_BUTTON:
      AddMember(sname);
      break;
*/
    case DECLARATION_BUTTON:
      {
	fname = proj.get_decl_file_from_function(cname,sname);
	lnum = proj.get_decl_line_from_function(cname,sname);
	if(fname) EditFile( fname, lnum);
      }
      break;

    case DEFINITION_BUTTON:
      {
	if( class_tree->IsLeaf(node)) // it is a function
	  {
	    fname = proj.get_file_from_function(cname,sname);
	    lnum = proj.get_line_from_function(cname,sname);
	  }
	else
	  {
	    fname = proj.get_file_from_class(sname);
	    lnum = proj.get_line_from_class(sname);
	  }
	if(fname)
	    EditFile( fname, lnum);
      }
      break;

    case UPDATE_CLASS_BUTTON:
      {
	if ( proj.isupdaterequired())
	  {
	    proj.update(); 
	    on_update();
	  }
	break;
      }
    }
  if(fname) delete[] fname;
  return true;
}

bool
VDKBCCPane::OnSelectRow(VDKObject* obj)
{
  VDKCustomTree* atree = dynamic_cast<VDKCustomTree*>(obj);
  atree = atree ? atree : class_tree;

  VDKTreeNode node = atree->SelectedNode;
  if(! node) return true;
  // get stored info
  char* cname = (char*) NULL;
  char* sname = new char[strlen(atree->Key(node))+1];
  strcpy(sname, atree->Key(node));

  // is a leaf without other info, it is a function
  if( atree->IsLeaf(node)) // it is a function
    {
      VDKTreeNode cnode = GTK_CTREE_ROW(node)->parent;//get class node
      cname = new char[strlen(atree->Key(cnode))+1];
      strcpy(cname, atree->Key(cnode));

//      (*toolbar)[ADD_FUNCTION_BUTTON]->Enabled = false;
      bool state = (proj.get_decl_line_from_function(cname,sname) != 0) ? true : false;
      (*toolbar)[DECLARATION_BUTTON]->Enabled = state;
      declared_item->Enabled = state;
      state = 	( proj.get_class_from_name( cname ). get_function_from_name( sname ).is_defined());
      (*toolbar)[DEFINITION_BUTTON]->Enabled = state;
      defined_item->Enabled = state;
      /*
      sprintf(buff,"%s : %d - %s : %d",
	      _(proj.get_file_from_function(cname,sname)),
	      proj.get_line_from_function(cname,sname),
	      _(proj.get_decl_file_from_function(cname,sname)),
	      proj.get_decl_line_from_function(cname,sname));
      bar->Panels()[0]->Caption = buff;
      */ 
    }
  else // it is a class
    {
      bool state = ( proj.get_class_from_name( sname ).is_defined());
//      (*toolbar)[ADD_FUNCTION_BUTTON]->Enabled = state;
      (*toolbar)[DEFINITION_BUTTON]->Enabled = state;
      defined_item->Enabled = state;
      (*toolbar)[DECLARATION_BUTTON]->Enabled = false;
      declared_item->Enabled = false;
      /* 
      sprintf(buff,"%s : %d",
	      _(proj.get_file_from_class(sname)),
	      proj.get_line_from_class(sname));
      */
      bar->Panels()[0]->Caption = buff;
    }

  return true;
}

void
VDKBCCPane::EditFile( const char* fname, int lnum)
{
  if ( fname != NULL)
    {
      VDKBMainForm* mainform = (VDKBMainForm*) owner->Owner();
      VDKBEditor* editor =   mainform->MakeEditor();

      // find text page
      int t  = 0;
      bool found = false;
      TextListIterator li(editor->textlist);
      for(t = 0; li; li++,t++)
	{
	  if(! strcmp( li.current()->Filename(),fname))
	    {
	      found = true;
	      break;
	    }
	}
      // not found, so make it
      if(! found)
	editor->AddText((char*)fname,true,true);

      editor->nbook->ActivePage = t;
      // finally goes to line
      (editor->textlist)[t]->GoToLine(lnum);
    }
}

/*
void
VDKBCCPane::AddMember(char* sname)
{
  SFuncWizard nfunc;
  nfunc.parent = sname;
  char* decfile = (char*) proj.get_file_from_class(sname);
  nfunc.decfile = decfile;
  int t = strlen(decfile)-1;
  char* deffile = decfile;
  deffile[t++] = 'c'; // only temporary
  deffile[t++] = 'c'; // should add cc_ext
  deffile[t] = '\0';
  nfunc.deffile = deffile;
  nfunc.isValid = false;
  Vdkb_FWizardForm* fw= new Vdkb_FWizardForm(Owner(),(char*)NULL,&nfunc);
  fw->Setup();
  fw->ShowModal(Vdkb_FWizardForm::InitialPosition);
  if( nfunc.isValid )
    {
//       int lnum = proj.get_line_from_class(sname);
//       EditFile((const char*)nfunc.decfile,lnum);
      TheApp->MessageBox(_("New Function Wizard"),
				_("You made a function, but for now\n it won't be made in files."),
				MB_OK | MB_ICONINFORMATION,
				NULL, NULL, 0);
    }
}
*/
